#/bin/sh
scantime=5
percent=50

[ -f /var/run/chronyd.pid  ] || exit 0

read PID < /var/run/chronyd.pid
if [ "$PID" -a -d /proc/$PID  ]
then
  maxjiffies=`expr $scantime \* $percent`
  set `cat /proc/$PID/stat`
  jiffies=$14
  sleep $scantime
  # Check if chronyd disappeared in the meantime (happens sometimes at boot-time)
  if [ -d /proc/$PID ]
  then
    set `cat /proc/$PID/stat`
    jiffiesneu=$14
    diff=`expr $jiffiesneu - $jiffies`
    if [ $diff -gt $maxjiffies ]
    then
      kill -ABRT $PID >/dev/null 2>&1
      kill -9 $PID >/dev/null 2>&1
      sleep 1
	  if [ -f /var/run/chronyd_ipv4.only ]
	  then
	    CHRONYDOPTIONS="-r -4"
	  else
	    CHRONYDOPTIONS="-r"
	  fi
      /usr/sbin/chronyd $CHRONYDOPTIONS
	  logger -t "chrony-watchdog" "chronyd was restarted by chrony-watchdog"
    fi
  fi
fi
